#include "orb_device.h"
#include "orb_translator.h"
#include "hid_keys.h"
#include "chart_4.h"

Logical_orb orb_buffer( SpaceOrb360 );
Orb_translator translator;
byte b;
boolean has_initialized_orb=false;

PROGMEM Axis_key_binding axis_key_bindings[] =
  {
    { 0, 0, 255, 0, KEY_A },
    { 0, 768, 1023, 0, KEY_D},
    { 1, 0, 255, 0, KEY_W},
    { 1, 768, 1023, 0, KEY_S},
    { 2, 0, 255, 0, KEY_N},
    { 2, 768, 1023, 0, KEY_U },
    { 3, 0, 255, 0, KEY_J},
    { 3, 768, 1023, 0, KEY_B },
    { 5, 0, 255, 0, KEY_Q },
    { 5, 768, 1023, 0, KEY_E }
  };

PROGMEM Button_key_binding button_key_bindings[] =
  {
    { 0x01 << 0, 0, KEY_K },
    { 0x01 << 1, 0, KEY_R },
    { 0x01 << 2, 0, KEY_G },
    { 0x01 << 3, 0, KEY_H },
    { 0x01 << 4, 0, KEY_L },
    { 0x01 << 5, 0, KEY_O }
  };
  
void setup()
{
  Serial.begin( 9600 );

  translator.set_axis_map( Axis_map_spaceorb_face );
  translator.set_polarity( Polarity_spaceorb_face );

  translator.set_axis_key_bindings( axis_key_bindings, 10 );
  translator.set_button_key_bindings( button_key_bindings, 6 );

  translator.set_gain( 30 );
  translator.set_axis_gain( 3, 4 );
  translator.set_axis_gain( 5, 4 );
  translator.set_sensitivity_table( sensitivity_4_chart );
  translator.set_precision_gain( -20 );
  translator.set_axis_precision_gain( 0, 30 );
  translator.set_precision_mask( 0x01 );

}

void loop()
{
  orb_device.refresh();
  if  ( Serial.available() )
  {
    b = Serial.read();
    orb_buffer.add_byte( b );
    if ( orb_buffer.has_changed() )
    {
      translator.update(orb_buffer, orb_device);
    }
  }
}
